config/routes.rb
Rails.application.routes.draw do
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  root "input_files#input"
  get "input_files/input", to: "input_files#input", as: "input_files_input"

  post "input_files/upload", to: "input_files#upload", as: "input_files_upload"
  get "input_files/upload", to: "input_files#upload_get", as: "input_files_upload_get"

  post "input_files/output", to: "input_files#output", as: "input_files_output"
  get "input_files/output", to: "input_files#output_get", as: "input_files_output_get"
end

app/models/board.rb
class Board
  # ------------ modules ------------
  include ActiveModel::Validations
  include BoardsModule

  # ------------ validations ------------
  validates :dimension,:move_set,:zombies_to_move, presence: true
  #empty Array [] is a valid value
  validates :creatures_alive, presence: true, unless: -> {creatures_alive.is_a?(Array)}
  validates_with AttributeClass, {attr_name:"move_set", classes_array:[MOVE_SET_CLASS]}
  validates_with AttributeClass, {attr_name:"dimension", classes_array:[DIMENSION_CLASS]}
  validates :dimension, numericality: {greater_than_or_equal_to: DIMENSION_MIN_VALUE}
  validates :move_set, format: InputFilesModule::REGEXES_BY_LINE[InputFilesModule::InputFileLines::MOVE_SET]
  validates_with ArrayAttributeValidity, {attr_name:"zombies_to_move",class_type:Zombie}
  validates_with ArrayAttributeValidity, {attr_name:"creatures_alive",class_type:Creature}
  validates_with BoardLogic,  if: -> {errors.empty?}
end

app/models/creature.rb
class Creature
  # ------modules-----------
  include ActiveModel::Validations
  include CreaturesModule

  # ------validations-----------
  validates :position, presence: true
  validates_with AttributeClass, {attr_name:"position", classes_array:[POSITION_CLASS]}
  validates_with AttributeValidity, {attr_name:"position", class_type:POSITION_CLASS}
end

app/models/input_file.rb
class InputFile
  # ------modules-----
  include ActiveModel::Validations
  include ActiveModel::Validations::Callbacks
  include InputFilesModule

  # ------validations------
  validates :input_file, presence: true
  validates_with AttributeClass, {attr_name:"input_file", classes_array:INPUT_FILE_CLASSES}
  validates_with InputFileContent, {attr_name:"input_file"}
  after_validation :set_input_lines,  if: -> {errors.empty?}

end

app/models/position_2_d.rb
class Position2D
  # ------- modules -----------
  include ActiveModel::Validations
  include Positions2DModule

  # ------- validations -----------
  validates :x,:y, presence: true
  #validates_with validates when :x or :y are numeric string i.e  "1" ,"2"
  validates_with AttributeClass, {attr_name:"x", classes_array:[X_CLASS]}
  validates_with AttributeClass, {attr_name:"y", classes_array:[X_CLASS]}
  #validates numericality doesn't add error with numeric string i.e  "1" "2"
  validates :x,:y, numericality: {only_integer: true, greater_than_or_equal_to: MIN_VALUE}

end

app/models/zombie.rb
class Zombie < Creature
  # ------modules-----------
  #it inherits Creature's modules
  include ZombiesModule

  # ------validations-----------
  #it inherits Creature's validations
  validates_with AttributeClass, {attr_name:"moved", classes_array:MOVED_CLASSES}
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/input_files_controller.rb
class InputFilesController < ApplicationController
  #GET "input_files/input"
  #GET root_url
  def input
  end

  #GET input_files/upload
  # case when refresh the output view.
  def upload_get
    render :input
  end

  #POST input_files/upload
  def upload
    input_file = InputFile.new(params[:file])
    if input_file.valid?
      board = input_file.to_board
      if board.valid?
        begin
          board.start_simulation #if error go to Exception
          @file_lines = input_file.file_lines
          @zombies_score = board.zombies_score
          @zombies_moved = board.zombies_moved
          render :output
        rescue =>  e #Any error is because board.valid? is false.
          flash.now[:error] = e #raised with StandardError.new(I18n.t('messages.errors.board.invalid'))
          render :input
        end
      else
        flash.now[:error] = board.errors.full_messages
        render :input
      end
    else
      flash.now[:error] = input_file.errors.full_messages
      render :input
    end
  end

  #POST input_files/output. render in upload
  def output
    @file_lines = []
    @zombies_score = -1
    @zombies_moved = []
  end
  #GET input_files/output.
  #case: when try to head to input_files/output. output is only POST
  def output_get
    render :input
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/zombie_helper.rb
module ZombieHelper
  EMPTY_STRING = ''.freeze

  def format_array_zombies(zombies_array)
    if zombies_array.is_a?(Array)
      output_string = EMPTY_STRING
      zombies_array.each do |z|
        output_string += "-(#{z.position.x},#{z.position.y}) "
      end
      output_string
    else
      EMPTY_STRING
    end
  end

end

app/views/input_files/input.html.erb
<h1>ZOMBIE APOCALYPSE</h1>
<h2>Upload Input File</h2>
<br>
<%= form_tag input_files_upload_path , multipart: true do %>
  <div class="field">
    <%= file_field_tag :file %>
  </div>
  <div class="actions btn btn-primary">
    <%= submit_tag 'Submit'%>
  </div>
<% end %>
<br>
<br>
| <%= link_to "Problem Description", "https://gitlab.com/dante.salcedo/zombie_apocalypse/-/blob/main/problem_description.md" %> | <%= link_to "Input Files", "https://gitlab.com/dante.salcedo/zombie_apocalypse/-/tree/main/input_files" %> | <%= link_to "Code", "https://gitlab.com/dante.salcedo/zombie_apocalypse/-/tree/main" %> |

app/views/input_files/output.html.erb
<%= stylesheet_pack_tag 'output' %>
<%= javascript_pack_tag 'output', media: 'all', 'data-turbolinks-track': 'reload' %>

<h1>Simulation Results</h1>

<table id="table_input">
  <thead>
  <tr>
    <th>Example Input</th>
    <th>Example Output</th>
  </tr>
  </thead>
  <tbody>
    <tr>
      <td>
        <%@file_lines.each do |line| %>
          <%= line %><br>
        <% end %>
      </td>
      <td>
        <b>zombies's score:</b> <%= @zombies_score %><br>
        <b>zombies's positions:</b><%= format_array_zombies(@zombies_moved) %>
      </td>
    </tr>
  </tbody>
</table>

<br>
<%= link_to "Home", root_path%>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>ZombieApocalypse</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <% flash.each do |type, msg| %>
      <div>
        <b>-<%=type.to_s+": " + msg.to_s %></b>
      </div>
    <% end %>
    <%= yield %>
  </body>
</html>